/*
*$Author: cf $
*$Id: pam_epass.c,v 1.2 2001/02/22 07:19:27 cf Exp $
*/
#include <features.h>
#include <sys/types.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <syslog.h>
#include <time.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/ioctl.h>

#include<sys/time.h>
#include <unistd.h>
#include "interface.h"

#define PAM_SM_AUTH
#define PAM_SM_ACCOUNT
#define PAM_SM_SESSION
#define PAM_SM_PASSWORD

#include <security/_pam_macros.h>
#include <security/pam_modules.h>

#ifndef LINUX_PAM
#include <security/pam_appl.h>
#endif

#define  HID1	0x12061407
#define  HID2	0x2107d005
#define  KEY1_DIR   3
#define  KEY1_ID    1
#define  KEY2_DIR   3
#define  KEY2_ID    2

PAM_EXTERN int pam_sm_authenticate(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	char keyText[7];
	unsigned char Challenge[55];
	EPS_CONTEXT ctx;
	int retval,a;
       	unsigned char digest[16];
       	unsigned char digest2[16];
       	
       	retval=EPS_OpenDevice(&ctx,EPS_OPEN_FIRST);
       	if(retval!=0){
       		printf("epass  error\n");
       		return retval;
       	}
        if((ctx.SerialNumber[0]!=HID1) || (ctx.SerialNumber[1]!=HID2))
        {
           printf("ePass illegal!\n");
           return 1;
        }
        for(a=0;a<55;a++)
        {

            Challenge[a]=(1*1000)%255;
        }
        strcpy(keyText,"epass");
        HMAC_MD5(Challenge,55,keyText,6,NULL,NULL,digest2);
        retval=EPS_HMAC_MD5(&ctx,KEY1_DIR,KEY1_ID,KEY2_DIR,KEY2_ID,Challenge,55,digest);
        if((retval=memcmp(digest,digest2,16))!=0){
        	printf("Auth error\n");
        	return retval;
        }
        EPS_CloseDevice(&ctx);
        return retval;
}

PAM_EXTERN int pam_sm_setcred(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	return PAM_SUCCESS;
}

PAM_EXTERN int pam_sm_acct_mgmt(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	return PAM_SUCCESS;
}

PAM_EXTERN int pam_sm_open_session(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	return PAM_SUCCESS;
}

PAM_EXTERN int pam_sm_close_session(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	return PAM_SUCCESS;
}

PAM_EXTERN int pam_sm_chauthok(pam_handle_t *pamh,int flags,int argc,const char **argv)
{
	return PAM_SUCCESS;
}

#ifdef PAM_STATIC
struct pam_module _pam_pwdb_modstruct={
	"pam_itoken",
	pam_sm_authenticate,
	pam_sm_setcred,
	pam_sm_acct_mgmt,
	pam_sm_open_session,
	pam_sm_close_session,
	pam_sm_chauthok
};
#endif
	
	
